SystemOrganization addCategory: #'LegoIR-Core'!

Object subclass: #LegoIRTower
	instanceVariableNames: 'port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LegoIR-Core'!

LegoIRTower class
	instanceVariableNames: 'connectedPortNumber'!

LegoIRTower class
	instanceVariableNames: 'connectedPortNumber'!

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 10/13/2010 14:37'!
connectOnPort: aString 
port := SerialPort new baudRate: 115200.
port := port
				openPort: (('COM*' match: aString)
						ifTrue: [aString asInteger]
						ifFalse: [aString]).
self isConnected ifFalse: [^self error: 'Port not connected']! !

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 10/13/2010 14:59'!
disconnect
self isConnected ifFalse: [^self].
port close.
port := nil! !

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 10/13/2010 14:39'!
isConnected
	^port notNil! !

!LegoIRTower methodsFor: 'sending' stamp: 'Richo 10/13/2010 17:37'!
send: hexCode numberOfTxBytes: numberOfTxBytes 
| list |
self isConnected ifFalse: [^self error: 'Not connected'].
list := OrderedCollection new.
8 * numberOfTxBytes timesRepeat: [list add: 0].
(hexCode printStringBase: 2)
	do: [:bit |
	bit = $1 ifTrue: [5 * numberOfTxBytes timesRepeat: [list add: 255]]
ifFalse: [numberOfTxBytes timesRepeat: [list add: 255]].
numberOfTxBytes timesRepeat: [list add: 0]
	].
^port nextPutAll: list asByteArray! !

!LegoIRTower methodsFor: 'sending' stamp: 'Richo 10/13/2010 17:18'!
sendIS: hexCode numberOfTxBytes: numberOfTxBytes 
	| list strCode |

	self isConnected
		ifFalse: [^ self error: 'Not connected'].
	list := OrderedCollection new.
	5 * numberOfTxBytes
		timesRepeat: [list add: 0].
	strCode := (hexCode printStringBase: 2).
	strCode size < 22 ifTrue: [
		(22 - strCode size) timesRepeat: [numberOfTxBytes
						timesRepeat: [list add: 255].
			numberOfTxBytes
				timesRepeat: [list add: 0]]
		].
	strCode
		do: [:bit | 
			bit = $1
				ifTrue: [2 * numberOfTxBytes
						timesRepeat: [list add: 255]]
				ifFalse: [numberOfTxBytes
						timesRepeat: [list add: 255]].
			numberOfTxBytes
				timesRepeat: [list add: 0]].
	^ port nextPutAll: list asByteArray! !
